io.vertx.ext.auth.oauth2

## Interface OAuth2Auth

- All Superinterfaces:
    AuthenticationProvider

      public interface OAuth2Auth
      extends AuthenticationProvider

  Factory interface for creating OAuth2 based `AuthenticationProvider` instances.
  Author:
    Paulo Lopes

- - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `String` | `authorizeURL(JsonObject params)` Deprecated. For type safety this method should be avoided and `authorizeURL(OAuth2AuthorizationURL)` should be used instead.
    `String` | `authorizeURL(OAuth2AuthorizationURL url)` The client sends the end-user's browser to this endpoint to request their authentication and consent.
    `void` | `close()` Releases any resources or timers used by this instance.
    `static OAuth2Auth` | `create(Vertx vertx)` Create a OAuth2 auth provider.
    `static OAuth2Auth` | `create(Vertx vertx, OAuth2Options config)` Create a OAuth2 auth provider
    `default String` | `endSessionURL(User user)` The logout (end-session) endpoint is specified in OpenID Connect Session Management 1.0.
    `String` | `endSessionURL(User user, JsonObject params)` The logout (end-session) endpoint is specified in OpenID Connect Session Management 1.0.
    `Future<Void>` | `jWKSet()` Retrieve the public server JSON Web Key (JWK) required to verify the authenticity of issued ID and access tokens.
    `default OAuth2Auth` | `jWKSet(Handler<AsyncResult<Void>> handler)` Retrieve the public server JSON Web Key (JWK) required to verify the authenticity of issued ID and access tokens.
    `OAuth2Auth` | `missingKeyHandler(Handler<String> handler)` Handled to be called when a key (mentioned on a JWT) is missing from the current config.
    `Future<User>` | `refresh(User user)` Refresh the current User (access token).
    `default OAuth2Auth` | `refresh(User user, Handler<AsyncResult<User>> handler)` Refresh the current User (access token).
    `default Future<Void>` | `revoke(User user)` Revoke an obtained access token.
    `default OAuth2Auth` | `revoke(User user, Handler<AsyncResult<Void>> handler)` Revoke an obtained access token.
    `Future<Void>` | `revoke(User user, String tokenType)` Revoke an obtained access or refresh token.
    `default OAuth2Auth` | `revoke(User user, String tokenType, Handler<AsyncResult<Void>> handler)` Revoke an obtained access or refresh token.
    `Future<JsonObject>` | `userInfo(User user)` Retrieve profile information and other attributes for a logged-in end-user.
    `default OAuth2Auth` | `userInfo(User user, Handler<AsyncResult<JsonObject>> handler)` Retrieve profile information and other attributes for a logged-in end-user.

    - ### Methods inherited from interface io.vertx.ext.auth.authentication.AuthenticationProvider

      `authenticate, authenticate, authenticate, authenticate`

- - ### Method Detail

    - #### create

          static OAuth2Auth create(Vertx vertx)

      Create a OAuth2 auth provider.
      Parameters:
        `vertx` - the Vertx instance
      Returns:
        the auth provider

    - #### create

          static OAuth2Auth create(Vertx vertx,
                                   OAuth2Options config)

      Create a OAuth2 auth provider
      Parameters:
        `vertx` - the Vertx instance
        `config` - the config
      Returns:
        the auth provider

    - #### jWKSet

          default OAuth2Auth jWKSet(Handler<AsyncResult<Void>> handler)

      Retrieve the public server JSON Web Key (JWK) required to verify the authenticity of issued ID and access tokens. The provider will refresh the keys according to: https://openid.net/specs/openid-connect-core-1_0.html#RotateEncKeys This means that the provider will look at the cache headers and will refresh when the max-age is reached. If the server does not return any cache headers it shall be up to the end user to call this method to refresh. To avoid the refresh to happen too late, this means that they keys will be invalid, if the `OAuth2Options` `JWTOptions` config contains a positive leeway, it will be used to request the refresh ahead of time. Key rotation can be controled by `OAuth2Options.setRotateJWKs(boolean)`.
      Parameters:
        `handler` - the handler success/failure.
      Returns:
        fluent self.

    - #### jWKSet

          Future<Void> jWKSet()

      Retrieve the public server JSON Web Key (JWK) required to verify the authenticity of issued ID and access tokens.
      Returns:
        Future result.
      See Also:
        `jWKSet(Handler)`

    - #### missingKeyHandler

          OAuth2Auth missingKeyHandler(Handler<String> handler)

      Handled to be called when a key (mentioned on a JWT) is missing from the current config. Users are advised to call `jWKSet(Handler)` but being careful to implement some rate limiting function. This method isn't generic for several reasons. The provider is not aware of the capabilities of the backend IdP in terms of max allowed API calls. Some validation could be done at the key id, which only the end user is aware of. A base implementation for this handler is:

             // are we already updating the jwks?
             private final AtomicBoolean updating = new AtomicBoolean(false);

             // default missing key handler, will try to reload with debounce
             oauth2.missingKeyHandler(keyId -> {
               if (updating.compareAndSet(false, true)) {
                 // Refreshing JWKs due missing key
                 jWKSet(done -> {
                   updating.compareAndSet(true, false);
                   if (done.failed()) {
                     done.cause().printStackTrace();
                   }
                 });
               }
             });

      This handler will purely debounce calls and allow only a single request to `jWKSet()` at a time. No special handling is done to avoid requests on wrong key ids or prevent to many requests to the IdP server. Users should probably also account for the number of errors to present DDoS the IdP.
      Returns:
        Future result.
      See Also:
        `missingKeyHandler(Handler)`

    - #### authorizeURL

          @Deprecated
          String authorizeURL(JsonObject params)

      Deprecated. For type safety this method should be avoided and `authorizeURL(OAuth2AuthorizationURL)` should be used instead.
      The client sends the end-user's browser to this endpoint to request their authentication and consent. This endpoint is used in the code and implicit OAuth 2.0 flows which require end-user interaction.
      Parameters:
        `params` - extra params to be included in the final URL.
      Returns:
        the url to be used to authorize the user.

    - #### authorizeURL

          String authorizeURL(OAuth2AuthorizationURL url)

      The client sends the end-user's browser to this endpoint to request their authentication and consent. This endpoint is used in the code and implicit OAuth 2.0 flows which require end-user interaction.
      Parameters:
        `url` - Base URL with path together with other parameters to be included in the final URL.
      Returns:
        the url to be used to authorize the user.

    - #### refresh

          default OAuth2Auth refresh(User user,
                                     Handler<AsyncResult<User>> handler)

      Refresh the current User (access token).
      Parameters:
        `user` - the user (access token) to be refreshed.
        `handler` - the handler success/failure.
      Returns:
        fluent self.

    - #### refresh

          Future<User> refresh(User user)

      Refresh the current User (access token).
      Parameters:
        `user` - the user (access token) to be refreshed.
      Returns:
        future result
      See Also:
        `userInfo(User, Handler)`

    - #### revoke

          default OAuth2Auth revoke(User user,
                                    String tokenType,
                                    Handler<AsyncResult<Void>> handler)

      Revoke an obtained access or refresh token. More info https://tools.ietf.org/html/rfc7009.
      Parameters:
        `user` - the user (access token) to revoke.
        `tokenType` - the token type (either access_token or refresh_token).
        `handler` - the handler success/failure.
      Returns:
        fluent self.

    - #### revoke

          default OAuth2Auth revoke(User user,
                                    Handler<AsyncResult<Void>> handler)

      Revoke an obtained access token. More info https://tools.ietf.org/html/rfc7009.
      Parameters:
        `user` - the user (access token) to revoke.
        `handler` - the handler success/failure.
      Returns:
        fluent self.

    - #### revoke

          Future<Void> revoke(User user,
                              String tokenType)

      Revoke an obtained access or refresh token. More info https://tools.ietf.org/html/rfc7009.
      Parameters:
        `user` - the user (access token) to revoke.
        `tokenType` - the token type (either access_token or refresh_token).
      Returns:
        future result
      See Also:
        `revoke(User, String, Handler)`

    - #### revoke

          default Future<Void> revoke(User user)

      Revoke an obtained access token. More info https://tools.ietf.org/html/rfc7009.
      Parameters:
        `user` - the user (access token) to revoke.
      Returns:
        future result
      See Also:
        `revoke(User, Handler)`

    - #### userInfo

          default OAuth2Auth userInfo(User user,
                                      Handler<AsyncResult<JsonObject>> handler)

      Retrieve profile information and other attributes for a logged-in end-user. More info https://openid.net/specs/openid-connect-core-1_0.html#UserInfo
      Parameters:
        `user` - the user (access token) to fetch the user info.
        `handler` - the handler success/failure.
      Returns:
        fluent self.

    - #### userInfo

          Future<JsonObject> userInfo(User user)

      Retrieve profile information and other attributes for a logged-in end-user. More info https://openid.net/specs/openid-connect-core-1_0.html#UserInfo
      Parameters:
        `user` - the user (access token) to fetch the user info.
      Returns:
        future result
      See Also:
        `userInfo(User, Handler)`

    - #### endSessionURL

          String endSessionURL(User user,
                               JsonObject params)

      The logout (end-session) endpoint is specified in OpenID Connect Session Management 1.0. More info: https://openid.net/specs/openid-connect-session-1_0.html.
      Parameters:
        `user` - the user to generate the url for
        `params` - extra parameters to apply to the url
      Returns:
        the url to end the session.

    - #### endSessionURL

          default String endSessionURL(User user)

      The logout (end-session) endpoint is specified in OpenID Connect Session Management 1.0. More info: https://openid.net/specs/openid-connect-session-1_0.html.
      Parameters:
        `user` - the user to generate the url for
      Returns:
        the url to end the session.

    - #### close

          void close()

      Releases any resources or timers used by this instance. Users are expected to call this method when the provider isn't needed any more to return the used resources back to the platform.

Copyright © 2024 Eclipse. All rights reserved.